Ext.namespace("dSS", "dSS.config", "dSS.devprops");
dSS.devprops.VisibilityMatrix = {
    'GE' :  {
                'KM:220'    :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                               },
                'KM:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                               },
                'KL:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                               },
                'TKM:210'   :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                               },
                'TKM:2'     :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : true
                               },
                'SDM:2'     :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                               },
                'SDS:210'   :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                               },
                'SDS:2'     :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                                },
                'TUP:220'    :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : true
                                },
                'TUP:2'      :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : true
                                },
                'ZWS:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                                }
            },
    'GN' :  {
                'KM:2'       :   {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false
                                },
                'TKM:210'    :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false
                                },
                'TKM:2'      :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : true,
                                    'pushbutton'    : false
                                },
                'TUP:210'    :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                },
                'TUP:2'      :  {
                                    'dontcare'      : false,
                                    'blink'         : false,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                },
                'SDS:2'     :  {
                                    'dontcare'      : false,
                                    'blink'         : false,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                }
            },
    'RT' :  {
                'KM:2'       :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false
                                },
                'TKM:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false
                                },
                'SDM:2'      :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : true,
                                    'pushbutton'    : false
                                },
                'SDS:2'      :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : true,
                                    'pushbutton'    : false
                                },
                'TUP:2'      :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                }
            },
    'GR' :  {
               'KL:220'      :   {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : false
                                 },
               'KL:2'        :   {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : false
                                 },
               'TKM:2'       :   {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : false
                                 },
               'TUP:220'     :   {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : false
                                 },
               'TUP:2'       :   {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : false
                                 }
            },
    'BL' :  {
                 'KM:2'       :  {
                                    'dontcare'      : true,
                                    'blink'         : false,
                                    'led'           : true,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                },
                 'KL:2'       : {
                                    'dontcare'      : true,
                                    'blink'         : false,
                                    'led'           : true,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                },
                 'SDS:2'      : {
                                    'dontcare'      : true,
                                    'blink'         : false,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                },
                 'TUP:2'      : {
                                    'dontcare'      : false,
                                    'blink'         : false,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : false
                                }
            },
    'TK' :  {
                 'TKM:2'     :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : false
                                },
                 'TUP:2'     :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : false
                                }
            },
    'SW' :  {
                  'TKM:2'     :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : true
                                 },
                  'KL:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : true,
                                    'pushbadvanced' : true
                                 },
                  'TUP:2'     :  {
                                    'dontcare'      : false,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : true
                                 },
                  'ZWS:2'     :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'pushbdevice'   : false,
                                    'pushbadvanced' : true
                                 }
            }
};

dSS.devprops.GetVisibleProperties = function(devClass, devType, devNumber) {
    var none = {
                   'dontcare'      : false,
                   'blink'         : false,
                   'led'           : false,
                   'transt'        : false,
                   'outmode'       : false,
                   'pushbutton'    : false,
                   'threshold'     : false,
                   'scenetranst'   : false,
                   'limitedpushbf' : false
               };

    var dc = dSS.devprops.VisibilityMatrix[dSS.config.deviceColors[devClass]];
    if (dc === undefined) {
        throw none;
    }

    var key = dSS.config.deviceTypes[devType] + ':' + devNumber;

    var ret = dc[key];
    if (ret === undefined) {
        // try wildcard
        key = dSS.config.deviceTypes[devType] + ':' +
              String(devNumber).charAt(0);
        ret = dc[key];
        if (ret === undefined) {
            throw none;
        } else {
            return ret;
        }
    } else {
        return ret;
    }
};

